import threading
import time
import sys
import pytest


class Helper:
    def __init__(self):
        self.app = None

    def launch(self):
        from PyQt6.QtCore import QSize, Qt
        from PyQt6.QtWidgets import QApplication, QMainWindow, QPushButton

        class MainWindow(QMainWindow):
            def __init__(self):
                super().__init__()##

                self.setWindowTitle("Test App")
                button = QPushButton("quit")
                self.setCentralWidget(button)
                button.clicked.connect(QApplication.quit)

        self.app = QApplication(sys.argv)
        window = MainWindow()
        window.show()
        print('starting event loop')
        self.app.exec()
        print('event loop done')


@pytest.fixture
def application():
    h = Helper()
    thread = threading.Thread(target=h.launch)
    thread.start()
    print('setup done')
    # case 0: wait for test to pass, then click "quit" button. test works as expected.
    # case 1: click "quit" button prior to test passing. test segfaults
    time.sleep(5)
    # case 2: replace the next line by "yield h.app". test segfaults
    yield
    # case 3: uncomment. test segfaults
    # h.app.quit()
    thread.join()
    print('teardown done')


def test_app(application):
    print('running scenario')
